<?php

namespace App\Http\Controllers\Admin\Structure;

use App\Filter\FilterClass\Claims\ClientEmail;
use App\Filter\FilterClass\Claims\ClientName;
use App\Filter\FilterClass\Claims\ProfileEmail;
use App\Filter\FilterClass\Claims\ProfileName;
use App\Filter\FilterClass\Claims\Text;
use App\Http\Controllers\Controller;
use App\Http\Resources\Admin\Structure\ClaimResource;
use App\Http\Resources\PaginationResource;
use App\Models\Claim;
use App\Traits\ApiResponser;
use App\Traits\pipeline;
use Illuminate\Http\Request;

class ClaimsController extends Controller
{
    use ApiResponser,pipeline,ApiResponser;
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
//        return Claim::query()->with('client')->get();
       $claim= $this->pipeline(Claim::query()->with('client','profile'),[Text::class,ProfileEmail::class,ClientEmail::class]);
    return  $this->onSuccess(new PaginationResource($claim,ClaimResource::collection($claim)) );
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
      $claim=  Claim::find($id);
        if (!$claim) {
            return $this->onFaile('claim not found');
        }
      if ($claim) {
          $claim->delete();
          return $this->onSuccess([]);
      }

    }
}
