<?php

namespace App\Http\Controllers\Admin\Structure;

use App\Http\Controllers\Controller;
use App\Http\Requests\TeamRequest;
use App\Http\Requests\UpdateTeamRequest;
use App\Models\Admin\Structure\Team;
use App\Models\HomeText;
use App\Traits\ApiResponser;
use App\Traits\Helper;
use Illuminate\Http\Request;

class TeamController extends Controller
{
    use ApiResponser,Helper;
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $team=Team::all();
     return   (isset($team))?$this->onSuccess($team):$this->onFaile($team);
//        Team::all();
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(TeamRequest $request)
    {
//        return $request;
        $requestValid=  $request->validated();
        $requestValid['image']= $this->photo($request->file('image'));
        $team = Team::create([
                'first_name' => $requestValid['first_name'],
                'last_name' => $requestValid['last_name'],
                'job' => $requestValid['job'],
                'about_us' => $requestValid['about_us'],
                'image' => $requestValid['image'],
            ]);


        return (isset($team)) ? $this->onSuccess($team) : $this->onFaile('Team Could not save ');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateTeamRequest $request, $id)
    {
        $team = Team::find($id);
//        return $team;

        if ($team)
            $team->update([
            'first_name' => $request['first_name'],
            'last_name' => $request['last_name'],
            'job' => $request['job'],
            'about_us' => $request['about_us'],
            'image' => $request['image'] !== null ? $this->photo($request['image']) : $team->image,
        ]);
        return ($team) ? $this->onSuccess(Team::find($id)) : $this->onFaile('Team Could not save ');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $team = Team::find($id);
        return ($team)
            ?  $this->onSuccess($team->delete()):
            $this->onFaile('team not found');
    }
}
