<?php

namespace App\Http\Controllers;

use App\Http\Requests\CreateClaimRequest;
use App\Models\Claim;
use App\Models\ParticipantsProject;
use App\Traits\ApiResponser;
use App\Traits\Helper;
use Illuminate\Http\Request;
use Illuminate\Support\Str;

class ClaimController extends Controller
{
    use Helper,ApiResponser;
    public $clientEntity;
    public $clientId;
    public $clientType;
    public function store($clientRole,CreateClaimRequest $request){

        $this->setInformation($clientRole);
//        $ProfileParticipantsProjectExists=ParticipantsProject::where('project_id',$request->project_id)->where('participants_project_id',$request->id)->where('participants_project_type',$this->getPathClass($request->type))->first();
//        if (!$ProfileParticipantsProjectExists)
//            return $this->onFaile('This client is not a member of the project');
        $profile=  $this->getPathClass($request->type)::find($request->id);
        if (!$profile)
            return $this->onFaile('client not found');
//        return $this->getPathClass($request->type);
        $claimExists=Claim::where('client_id',$this->clientId)->where('client_type',$this->clientType)->where('profile_id',$request->id)->where('profile_type',$this->getPathClass($request->type))->first();
        if ($claimExists)
            return $this->onFaile('You have already submitted your request');
//        $participantsProject=ParticipantsProject::where('project_id',$request->project_id)->where('role',ParticipantsProject::CREATORE_ROLE)->first();
//        if ($participantsProject)
//        if ($participantsProject->participants_project_id!=$this->clientId && $participantsProject->participants_project_type!=$this->clientType)
//            return $this->onFaile('permission denied');
        if (($request->image))
           $photo =$this->photo($request->image);
//        return $photo;
        $claim=Claim::create([
            'text'=>$request->text??null,
            'image'=>$photo??null,
            'client_id'=>$this->clientId,
            'client_type'=>$this->clientType,
            'profile_id'=>$request->id,
            'profile_type'=>$this->getPathClass($request->type),
//            'project_id'=>$request->project_id
        ]);
        return ($claim)?$this->onSuccess($claim):$this->onFaile('The operation failed');
    }
    public function setInformation($clientRole)
    {
        $this->clientType = 'App\\Models\\' . Str::ucfirst($clientRole);
        $this->clientEntity = auth($clientRole)->user();
        $this->clientId = $this->clientEntity->id;
        $this->client = $this->clientType::find($this->clientId);
        return 1;
    }
}
