<?php
//
//namespace App\Http\Controllers;
//
//use App\Models\BillingPlan;
//use App\Models\Transaction;
//use Illuminate\Http\Request;
//use Shetabit\Multipay\Invoice;
//use Shetabit\Payment\Facade\Payment as Payments;
//class PaymentController extends Controller
//{
//    public function __construct()
//    {
//        //$this->middleware('auth:sanctum');
//    }
//
//    public function index()
//    {
//
//    }
//
//    public function purchase(BillingPlan $billingPlan)
//    {
//        $Invoice = new Invoice();
//        $Invoice->amount(10000);
//
//        $payments = Payments::callbackUrl('https://localhost:8000/api/showComment', [1]);
//        $payments->purchase($Invoice, function ($driver, $transactionId){
//
//        });
//
//        return $payments->pay()->render();
//    }
//}


namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use App\Models\Transaction;
use GuzzleHttp\Client;
use Illuminate\Http\Request;
use Illuminate\Support\Carbon;
use Illuminate\Support\Facades\Cache;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Str;
use Illuminate\Validation\Rule;
use Omnipay\Common\GatewayInterface;
use Omnipay\Omnipay;
use Shetabit\Multipay\Exceptions\InvalidPaymentException;
use Shetabit\Multipay\Invoice;
use Shetabit\Payment\Facade\Payment;
use Srmklive\PayPal\Services\PayPal as PayPalClient;

class PaymentController extends Controller
{
    private $gateway;

    public function __construct()
    {
        $this->gateway = Omnipay::create('PayPal_Rest');
        $this->gateway->setClientId('AfpIEv6AJm2DV9E9xhQAWKN4sIc3_vdrzq9BsWNYrmCbBCW9uotJfMbRORb9oxcL7sXjOndkFKHeKvgR');
        $this->gateway->setSecret('ECXh4HtvjFdgNTMmSaD-gZO1byTDwfggjXZfuVhzjXhn5zooQ6gJQ-IijTNG6PB72gK-scLk-ZPxHaTY');
        $this->gateway->setTestMode(true);
    }

    public function charge(Request $request)
    {
        $amount = 2000;

        try {
            $response = $this->gateway->purchase([
                'amount' => $amount,
                'currency' => 'USD',
                'returnUrl' => url('success'),
                'cancelUrl' => route('paypal.error'),
            ])->send();

            if ($response->isSuccessful()) {
                return response()->json([
                    'success' => true,
                    'data' => [
                        'link' => $response->getData()['links'][1]['href']
                    ]
                ]);
            }
            return response()->json([
                'success' => false,
                'data' => null,
                'message' => $response->getMessage()
            ]);
        } catch (\Exception $e) {
            return response()->json([
                'success' => false,
                'data' => null,
                'message' => $e->getMessage()
            ]);
        }
    }

    public function success(Request $request)
    {
        // Once the transaction has been approved, we need to complete it.
        if ($request->paymentId && $request->PayerID) {
            $transaction = $this->gateway->completePurchase([
                'payer_id' => $request->PayerID,
                'transactionReference' => $request->paymentId,
            ]);
            $response = $transaction->send();

            if ($response->isSuccessful()) {
                // The customer has successfully paid.
                $arr_body = $response->getData();
                //dd($arr_body);
                // Insert transaction data into the database
                $payment = new Payment;
                $payment->payment_id = $arr_body['id'];
                $payment->payer_id = $arr_body['payer']['payer_info']['payer_id'];
                $payment->payer_email = $arr_body['payer']['payer_info']['email'];
                $payment->amount = $arr_body['transactions'][0]['amount']['total'];
                $payment->currency = env('PAYPAL_CURRENCY');
                $payment->payment_status = $arr_body['state'];
                $payment->save();

                return "Payment is successful. Your transaction id is: " . $arr_body['id'];
            } else {
                return $response->getMessage();
            }
        } else {
            return 'Transaction is declined';
        }
    }

    public function error(Request  $request)
    {
        return 'User cancelled the payment. transaction_id: '.$request->token;
    }


//    public function success(Request $request)
//    {
//        // Once the transaction has been approved, we need to complete it.
//        if ($request->input('paymentId') && $request->input('PayerID')) {
//            $transaction = $this->gateway->completePurchase(array(
//                'payer_id' => $request->input('PayerID'),
//                'transactionReference' => $request->input('paymentId'),
//            ));
//            $response = $transaction->send();
//
//            if ($response->isSuccessful()) {
//                // The customer has successfully paid.
//                $arr_body = $response->getData();
//
//                // Insert transaction data into the database
//                $payment = new Payment;
//                $payment->payment_id = $arr_body['id'];
//                $payment->payer_id = $arr_body['payer']['payer_info']['payer_id'];
//                $payment->payer_email = $arr_body['payer']['payer_info']['email'];
//                $payment->amount = $arr_body['transactions'][0]['amount']['total'];
//                $payment->currency = env('PAYPAL_CURRENCY');
//                $payment->payment_status = $arr_body['state'];
//                $payment->save();
//
//                return "Payment is successful. Your transaction id is: " . $arr_body['id'];
//            } else {
//                return $response->getMessage();
//            }
//        } else {
//            return 'Transaction is declined';
//        }
//    }

    /**
     * Error Handling.
     */
//    public function error()
//    {
//        return 'User cancelled the payment.';
//    }

//    public function pay(Request $request)
//    {
//
//        $provider = new PayPalClient();
//        $provider->getAccessToken();
//        $in = $provider->generateInvoiceNumber();
////
////        $data = json_decode('{
////  "detail": {
////    "invoice_number": "00001",
////    "reference": "deal-ref",
////    "invoice_date": "2018-11-12",
////    "currency_code": "USD",
////    "note": "Thank you for your business.",
////    "term": "No refunds after 30 days.",
////    "memo": "This is a long contract",
////    "payment_term": {
////      "term_type": "NET_10",
////      "due_date": "2018-11-22"
////    }
////  },
////  "invoicer": {
////    "name": {
////      "given_name": "David",
////      "surname": "Larusso"
////    },
////    "address": {
////      "address_line_1": "1234 First Street",
////      "address_line_2": "337673 Hillside Court",
////      "admin_area_2": "Anytown",
////      "admin_area_1": "CA",
////      "postal_code": "98765",
////      "country_code": "US"
////    },
////    "email_address": "merchant@example.com",
////    "phones": [
////      {
////        "country_code": "001",
////        "national_number": "4085551234",
////        "phone_type": "MOBILE"
////      }
////    ],
////    "website": "www.test.com",
////    "tax_id": "ABcNkWSfb5ICTt73nD3QON1fnnpgNKBy- Jb5SeuGj185MNNw6g",
////    "logo_url": "https://example.com/logo.PNG",
////    "additional_notes": "2-4"
////  },
////  "primary_recipients": [
////    {
////      "billing_info": {
////        "name": {
////          "given_name": "Stephanie",
////          "surname": "Meyers"
////        },
////        "address": {
////          "address_line_1": "1234 Main Street",
////          "admin_area_2": "Anytown",
////          "admin_area_1": "CA",
////          "postal_code": "98765",
////          "country_code": "US"
////        },
////        "email_address": "bill-me@example.com",
////        "phones": [
////          {
////            "country_code": "001",
////            "national_number": "4884551234",
////            "phone_type": "HOME"
////          }
////        ],
////        "additional_info_value": "add-info"
////      },
////      "shipping_info": {
////        "name": {
////          "given_name": "Stephanie",
////          "surname": "Meyers"
////        },
////        "address": {
////          "address_line_1": "1234 Main Street",
////          "admin_area_2": "Anytown",
////          "admin_area_1": "CA",
////          "postal_code": "98765",
////          "country_code": "US"
////        }
////      }
////    }
////  ],
////  "items": [
////    {
////      "name": "Yoga Mat",
////      "description": "Elastic mat to practice yoga.",
////      "quantity": "1",
////      "unit_amount": {
////        "currency_code": "USD",
////        "value": "50.00"
////      },
////      "tax": {
////        "name": "Sales Tax",
////        "percent": "7.25"
////      },
////      "discount": {
////        "percent": "5"
////      },
////      "unit_of_measure": "QUANTITY"
////    },
////    {
////      "name": "Yoga t-shirt",
////      "quantity": "1",
////      "unit_amount": {
////        "currency_code": "USD",
////        "value": "10.00"
////      },
////      "tax": {
////        "name": "Sales Tax",
////        "percent": "7.25"
////      },
////      "discount": {
////        "amount": {
////          "currency_code": "USD",
////          "value": "5.00"
////        }
////      },
////      "unit_of_measure": "QUANTITY"
////    }
////  ],
////  "amount": {
////    "breakdown": {
////      "custom": {
////        "label": "Packing Charges",
////        "amount": {
////          "currency_code": "USD",
////          "value": "10.00"
////        }
////      },
////      "shipping": {
////        "amount": {
////          "currency_code": "USD",
////          "value": "10.00"
////        },
////        "tax": {
////          "name": "Sales Tax",
////          "percent": "7.25"
////        }
////      },
////      "discount": {
////        "invoice_discount": {
////          "percent": "5"
////        }
////      }
////    }
////  }
////}', true);
////        $Invoice = $provider->createInvoice($data);
////        dd($Invoice);
//        $payment_method = 'PAYPAL';
//
//        $payment_date = now()->toDateString();
//
//        $amount = 10;
//
//        $invoice_no = 'INV2-4T29-2S87-3NA3-WUSX';
//
//        $status = $provider->registerPaymentInvoice($invoice_no, $payment_date, $payment_method, $amount,);
//        dd($status);
//
//        /*//این خط برای validate کردن اطلاعات مورد نیاز هست
//        $validatedData = $request->validate([
//            'mobile' => ['nullable', 'numeric', 'in:0,1'],
//            'rule' => ['required', 'numeric', 'in:1']
//        ]);
//
//        // تو این خط درواقع بررسی میکنم که کاربر با اپ موبایل درخواست پرداخت داده یا نه
//        // این پارامتر از سمت موبایل کار میاد و به فرانت کار مربوط نیست
//        // برای همین بالاتر اختیاری تعریفش کردم
//        $isApp = !!($validatedData['mobile'] ?? null);*/
//
//        $user = auth("user")->user();
//
//        //abort_if($user->id !== $order->user_id, 404);
//
//        //اینجا دارم اطلاعات تراکنش رو میگیرم
//        //$order->load(['transaction' => fn($q) => $q->success(), 'insurance', 'delivery', 'installment']);
//
//        // اینجا دارم قیمت پست رو میگیرم که برای محصولات فیزیکی هست
//        //$deliveryPrice = $order->delivery->deliveryTime->price ?? 0;
//
//        // اینجا چک میکنم که سفارش حتما آماده پرداخت باشه یا نه
////        if ($order->status !== Order::STATUS_PAYMENT)
////            return response()->json([
////                'success' => false,
////                'message' => 'اطلاعات و مشخصات ناقص است'
////            ]);
//
//
//        // اینجا چک میکنم که سفارش موفق قبلا داشته برای سسفارش فعلی یانه. دقت کنید که بالاتر در متد load از $q->success() استفاده کرده بودم.
//        /*if ($order->transaction)
//            return response()->json([
//                'success' => false,
//                'message' => 'این سفارش قبلا پرداخت شده است!'
//            ]);*/
//
//        //محاسبه قیمت نهایی
//        //$amount = $order->installment ? (int)$order->installment->pre_payment + (int)$deliveryPrice : (int)$deliveryPrice + (int)$order->price;
//
//        // ایجاد یک فاکتور یا صورتحساب
//        // این کلاس برای خود پکیج هست که اینجا قیمت نهایی و یه توضیح دلخواه دادم
//        $amount = 20000;
//        $Invoice = new Invoice();
//        $Invoice->amount($amount)
//            ->detail('description', "get plan");
//
//        //try {
//        //شروع فرایند خرید
//        $payment = Payment::callbackUrl('http://localhost:8080/api/verify')
//            ->purchase($Invoice, function ($driver, $transactionId) use ($user, $amount) {
//                // $driverName = Str::lower(Str::afterLast(get_class($driver), '\\'));
//
//                dd('kl;');
//                //ذخیره کردن تراکنش و transactin_id در دیتابیس
//                $user->transactions()->create([
//                    'billing_plan_id' => 1,
//                    'transaction_id' => $transactionId,
//                    'gateway' => config("payment.drivers.$driverName.title", $driverName),
//                    'amount' => $amount,
//                    'ref_id' => 23334,
//                ]);
//
//            })->pay();
//
//
//        return response()->json([
//            'success' => true,
//            'data' => [
//                // دریافت لینک درگاه
//                // دقت کنید که این لینک باید برای فرانت کار یا موبایل کار ارسال بشه
//                'link' => $payment->getAction()
//            ]
//        ]);
////        } catch (\Exception $e) {
////            Log::error($e);
////            return response()->json([
////                'success' => false,
////                'message' => 'خطایی رخ داد',
////                'code' => $e->getcode()
////            ]);
////        }
//    }


//    public function verify(Request $request)
//    {
//        //بررسی ازلاعات پرداخت شده
//        $request->validate([
//            'transaction_id' => ['required', 'string'],
//            'Status' => ['required', 'string', Rule::in(['OK', 'NOK'])]
//        ]);
//
//        // بررسی موجود بودن تراکنش و دریافت آن
//        $transaction = Transaction::with('order')
//            ->where('transaction_id', $request->transaction_id)
//            ->firstOrFail();
//
//        // چک کردن این که کاربر از موبایل وارد شده یا نه
//        $isApp = Cache::has("transaction_{$request->transaction_id}");
//
//        // اینم معلومه :)
//        if (!$transaction || !$transaction->order)
//            return response()->json([
//                'success' => false,
//                'data' => [
//                    'app' => $isApp
//                ],
//                'message' => 'تراکنش معتبر نمی باشد'
//            ], 404);
//
//        // اینم همینطور XD
//        if ($transaction->ref_id) {
//            return response()->json([
//                'success' => false,
//                'data' => [
//                    'app' => $isApp
//                ],
//                'message' => 'تراکنش قبلا پرداخت شده است'
//            ]);
//        }
//        $amount = 20000;
//
//        try {
//            // بررسی وضعیت پرداخت
//            // این خط قیمت و تراکنش رو با بانک چک میکنه که آیا پرداخت شده یا نه
//            // اگر پرداخت نشده بود قسمت catch اجرا میشه
//            $receipt = Payment::amount($amount)->transactionId(1)->verify();
//
//            // چون پرداخت اینجا موفق بود، پس وضعیت پرداخت رو میزاریم روی پرداخت موفق
//            $transaction->update([
//                'ref_id' => $receipt->getReferenceId(),
//                'status' => 'success'
//            ]);
//
//            // چون پرداخت اینجا موفق بود، پس وضعیت سفارش رو میزاریم روی پرداخت شده
//            /* $transaction->client->update([
//                 'status' => 'Order::STATUS_PAYED'
//             ]);*/
//            // این مهم نیست :)
//            //$transaction->unsetRelation('order');
//
//            return response()->json([
//                'success' => true,
//                'data' => [
//                    'reference' => $receipt->getReferenceId(),
//                    'transaction' => $transaction,
//                    'app' => $isApp
//                ],
//                'message' => 'پرداخت با موفقیت انجام شد'
//            ]);
//        } catch (InvalidPaymentException $exception) {
//
//            // اینجا چون پرداخت موفق نبوده، وضعیت پرداخت رو میزارم روی پرداخت ناموفق
//            $transaction->update([
//                'status' => 'fails'
//            ]);
//
//            //$transaction->unsetRelation('order');
//
//            return response()->json([
//                'success' => false,
//                'data' => [
//                    'transaction' => $transaction,
//                    'message' => $exception->getMessage(),
//                    'code' => $exception->getCode(),
//                    'app' => $isApp
//                ],
//                'message' => 'پرداخت با شکست مواجه شد'
//            ]);
//        }
//    }

    public function paypal(Request $request)
    {
        $username = 'AfpIEv6AJm2DV9E9xhQAWKN4sIc3_vdrzq9BsWNYrmCbBCW9uotJfMbRORb9oxcL7sXjOndkFKHeKvgR';
        $password = 'ECXh4HtvjFdgNTMmSaD-gZO1byTDwfggjXZfuVhzjXhn5zooQ6gJQ-IijTNG6PB72gK-scLk-ZPxHaTY';
        $uri = 'https://api-m.sandbox.paypal.com/v1/oauth2/token';
        $credentials = base64_encode($username . ':' . $password);
        $client = new Client();
        $response = $client->request('post', $uri, [
            'verify' => false,
            'headers' => [
                'accept' => 'application/json',
                'content-type' => 'application/x-www-form-urlencoded',
                'accept-language' => 'ea_US',
                'authorization' => ['Basic ' . $credentials],
            ],
            'form_params' => [
                'grant_type' => 'client_credentials'

            ],

        ]);
        $body = json_decode($response->getBody(), true);
        //dd($body);


        $access_token = 'Bearer ' . $body['access_token'];
        $uri2 = 'https://api-m.sandbox.paypal.com/v1/payments/payouts';
        $time = (string)Carbon::now()->timestamp;
        $batchId = $time;
        $amount = 0;

        $amount = (string)$amount;

        $response2 = $client->request('post', $uri2, [
            'headers' => [
                'Content-Type' => 'application/json',
                'Accept' => 'application/json',
                'Authorization' => $access_token
            ],
            'json' => [
                "sender_batch_header" => [
                    "sender_batch_id" => "" . $batchId, // should be unique each time
                    "email_subject" => "You have a payout!",
                    "email_message" => "You have received a payout! Thanks for using our service!"
                ],
                "items" => [
                    [
                        "recipient_type" => "EMAIL",
                        "amount" => [
                            "value" => 10,
                            "currency" => "USD"
                        ],
                        "note" => "Paypal payout.",
                        "sender_item_id" => "1",
                        "receiver" => "kimiaorouskhani@gmail.com",
//                        "receiver" => "".$request->email,
//                        "alternate_notification_method" => [
//                            "phone" => [
//                                "country_code" => "1",
//                                "national_number" => "4086276128"
//                            ]
//                        ],
                        "notification_language" => "fr-FR"
                    ],
                ]
            ],
        ]);
        $body2 = json_decode($response2->getBody(), true);
        dd($body2);


    }
}
