<?php

namespace App\Http\Requests\Admin\MangeAdmin;

use Illuminate\Foundation\Http\FormRequest;

class CreateAdminRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        return [
            'name'=>'required|min:3',
            'email'=>'required|unique:admins|email',
            'password'=>'required|min:8',
            'role_id'=>'required|numeric|exists:roles,id'

        ];
    }
//    public function messages()
//    {
//        return [
//            'name.required'=>'قیلد نام اجباری می باشد',
//            'name.min'=>'فیلد نام نمیتواند کمتر از 3 کاراکتر باشد',
//            'email.unique'=>'ایمیل وارد شده تکراری می باشد',
//            'email.required'=>'فیلد ایمیل الزامی می باشد',
//            'email.email'=>'فرمت مقدار وارد شده باید به صورت ایمیل باشد',
//            'password.required'=>'فیلد رمز عبور الزامی می باشد',
//            'password.min'=>'رمز عبور نمی تواند کمتر از 8 کاراکتر باشد',
//            'role_id.required'=>'ایدی نقش الزامی می باشد',
//            'role_id.numeric'=>'فرمت ایدی نقش مورد نظر معتبر نیست',
//        ];
//    }
}
