<?php

namespace App\Http\Resources\Admin;

use App\Models\User;
use Illuminate\Http\Resources\Json\JsonResource;

class GroupChatResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array|\Illuminate\Contracts\Support\Arrayable|\JsonSerializable
     */
    public function toArray($request)
    {   
        return [
            'id'=>$this->id,
            'title'=>$this->title,
            'creator_name'=>$this->creator->member_type == User::class ?
                $this->creator->member->name." ".$this->creator->member->last_name :
                $this->creator->member->name
            ,
            'creator_email'=>$this->creator->member->email,
            'type'=>$this->type,
        ];
    }
}
