<?php

namespace App\Http\Resources;

use App\Models\ParticipantsProject;
use Illuminate\Http\Resources\Json\JsonResource;
use Illuminate\Support\Facades\Auth;
use Mojtaba\Chatable\Models\Member;
use Svg\Tag\Group;

class ListGroupsResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param \Illuminate\Http\Request $request
     * @return array|\Illuminate\Contracts\Support\Arrayable|\JsonSerializable
     */
    public function toArray($request)
    {
//        return parent::toArray($request);

        $image = ParticipantsProject::query()
            ->with(['participantsProject' => function ($q) {
                $q->select('id', 'image')->take(4);
            }])->select('participants_project_type', 'participants_project_id')
            ->get();
        $admin=Member::where('group_id', $this->id)->where('member_id', $this->client_id)
            ->where('member_type', $this->client_type)->where('role', 'admin')->first();
        $images = ShowGroupResource::collection($image)->resolve();
//        return $this->groups  ;
//        return Auth::user();
        return ['id' => $this->id,
            "is_admin"=>isset($admin)??false,
//            "is_admin"=>empty($admin),
//            "is_admin"=>$admin,
            'image' => [$this->when(isset($images[0]), $images[0] ?? null), $this->when(isset($images[1]), $images[1] ?? null), $this->when(isset($images[2]), $images[2] ?? null), $this->when(isset($images[3]), $images[3] ?? null)],
            'uuid' => $this->uuid,
            'type' => $this->type,
            'name' => $this->title
            ,'address' => $this->address,
            'subject' => $this->subject,
            'messages_count' => $this->messages_count
        ];
    }
}
