<?php

namespace App\Mail;

use App\Models\User;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Support\Facades\Cache;

class ConfirmMail extends Mailable
{
    use Queueable, SerializesModels;

    protected $email;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($email)
    {
        $this->email = $email;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        $confirmationCode = rand(10000, 99999);
        $value = Cache::put($this->email, $confirmationCode, now()->addMinute(3));

        return $this->from(env('FROM_EMAIL'), env('APP_NAME'))
            ->subject('ProScreenPin Confirmation')
            ->markdown('mail.confirmation')
            ->with([
                'confirmationCode' => $confirmationCode,
            ]);
    }
}
