<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class MessageMail extends Mailable
{
    use Queueable, SerializesModels;

    public $time;
    public $message;
    public $email;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($email, $message, $time)
    {
        $this->time = $time;
        $this->message = $message;
        $this->email = $email;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->from(env('FROM_EMAIL'), 'Vista')
            ->subject('ProScreenPin Message')
            ->markdown('mail.Message')
            ->with([
                'confirmationCode' => $this->message,
                'timeStamp' => $this->time,
                'email' => $this->email
            ]);
    }
}
