<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Storage;

class Estimate extends Model
{
    use HasFactory;
    protected $guarded = ['id'];

    public function estimateable()
    {
        return $this->morphTo();
    }

    public function lists()
    {
        return $this->morphMany(ServiceList::class, 'listable');
    }
    public function client()
    {
        return $this->morphMany(ServiceList::class, 'clientList','clientList_type','clientList_id');
    }

    public function getImageAttribute($value)
    {
        return $value != null ? Storage::disk('public')->url('images/' . $value) : $value;
    }
    public function getpdfAddressAttribute($value)
    {
        return $value != null ? Storage::disk('public')->url($value) : null;
    }
}
