<?php

namespace App\Repositories;

use App\Filter\FilterClass\Report\Q;
use App\Models\Report;
use App\Traits\ApiResponser;
use App\Traits\Helper;
use App\Traits\pipeline;
use JasonGuru\LaravelMakeRepository\Repository\BaseRepository;

//use Your Model

/**
 * Class ReportRepository.
 */
class ReportRepository extends BaseRepository
{
    use pipeline;
    /**
     * @return string
     *  Return the model
     */
    public function model()
    {
        return Report::class;
    }

    public function storeReport($request, $id, $type)
    {
        do{
            $rand=rand(000000,999999);
            $number= Report::where('project_reference_number',$rand)->first();
        }while($number==$rand);

        return Report::create([
            'project_reference_number' => $rand,
            'project_name' => isset($request['project_name']) ? $request['project_name'] : null,
            'description' => isset($request['description']) ? $request['description'] : null,
            'reportable_id' => $id,
            'reportable_type' => $type,
        ]);
    }
    public function showReport($type, $id)
    {
        return  $this->pipeline(Report::query()->where('reportable_type', $type)->where('reportable_id', $id)
            ->with(['images' => function($query) {
                $query->take(4);
            }]),[Q::class]);
    }

    public function update($id)
    {

    }

    public function exists($id, $clientType, $clientId)
    {
        return Report::where('id', $id)->where('reportable_id', $clientId)->where('reportable_type', $clientType)->with('images')->first();
    }
}
