<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateInvoicesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('invoices', function (Blueprint $table) {
            $table->id();
            $table->string('customer_name');
            $table->string('customer_email');
            $table->string('reference_number')->unique();
            $table->text('term');
            $table->string('invoiceable_type'); //user or company
            $table->unsignedInteger('invoiceable_id');
            $table->date('start_date');
            $table->date('end_date');
            $table->text('address');
            $table->decimal('longitude', 10,7)->nullable();
            $table->decimal('latitude', 10 , 7)->nullable();
            $table->text('message');
            $table->text('image')->nullable();
            $table->unsignedInteger('sub_total');
            $table->unsignedInteger('discount');
            $table->string('discount_type');
            $table->unsignedInteger('sale_tax');
            $table->unsignedInteger('total');
            $table->unsignedInteger('deposit');
            $table->enum('status', ['sent', 'delivered', 'paid'])->nullable();
            $table->text('report')->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('invoices');
    }
}
